<?php
class fieldSource extends cmsFormField {
    public $title       = 'Источник';
    public $sql         = 'varchar({max_length}) NULL DEFAULT NULL';
    public $filter_type = 'str';
    public $allow_index = false;
    public $var_type    = 'string';
    public function getOptions(){
        return array(
            new fieldCheckbox('redirect', array(
                'title' => LANG_PARSER_URL_REDIRECT,
                'default' => false
            )),
            new fieldCheckbox('auto_http', array(
                'title' => LANG_PARSER_URL_AUTO_HTTP,
                'default' => true
            )),
            new fieldNumber('max_length', array(
                'title' => LANG_PARSER_TEXT_MAX_LEN,
                'default' => 500
            )),
            new fieldCheckbox('nofollow', array(
                'title'   => 'Добавлять к ссылке тег nofollow',
                'default' => false
            )),
            new fieldCheckbox('title', array(
                'title'   => 'Разрешить указывать заголовок ссылки',
                'default' => false
            )),
            new fieldString('css_class', array(
                'title'   => 'CSS-класс для ссылок',
                'rules'   => array(
                    array('max_length', 50)
                )
            ))
        );
    }
    public function parse($value){
        if (!$this->getOption('title') && strpos('|', $value) === false){
            $href = $value;
        } else {
            $result = explode('|', $value);
            $href = trim($result[0]);
            if(!empty($result[1])){
                $value = trim($result[1]);
            }
        }
        if ($this->getOption('auto_http')){
            if (!preg_match('/^([a-z]+):\/\/(.+)$/i', $href)) { $href = 'http://' . $href; }
        }
        if ($this->getOption('redirect')){
            $href = cmsConfig::get('root') . 'redirect?url=' . urlencode($href);
        }
        $nofollow = $class = '';
        if ($this->getOption('nofollow')){
            $nofollow = ' nofollow';
        }
        if ($this->getOption('css_class')){
            $class = ' class="'.$this->getOption('css_class').'"';
        }
        return '<a rel="noopener'.$nofollow.'" target="_blank" '.$class.' href="'.htmlspecialchars($href).'">'.htmlspecialchars($value).'</a>';
    }
    public function applyFilter($model, $value) {
        return $model->filterLike($this->name, "%{$value}%");
    }
    public function store($value, $is_submitted, $old_value=null){
        return strip_tags($value);
    }
}